#ifndef _NNCLASSIFIER_H
#define _NNCLASSIFIER_H

// Holds the weight matrix for the 15x12 A-Z NN classifier,
// along with all functions necessary for classification.

// Additionally, contains functions necessary for drawing cleanup
// so that the NN has a clean input.

#include <math.h>
#include "constants.h"
#include <inttypes.h>

// Cleans the input in argument 1 by removing connected groups of size <= THRESHOLD_SZ
// Outputs to argument 2-5:
// 2: Minimum x value in cleaned input at which there exists an "on" pixel
// 3: Maximum x value ""												""
// 4: Minimum y value ""												""
// 5: Maximum y value ""												""
void clean_input(uint8_t input[X_RES][Y_RES/8], uint8_t*, uint8_t*, uint8_t*, uint8_t*);

// Uses the normalized drawing in input and determines which letter (A-Z)
// it resembles most.
char NNclassify(uint8_t input[X_SCALED][(Y_SCALED+7)/8]);

#endif
