#ifndef _CONSTANTS_H
#define _CONSTANTS_H

#define true 1
#define false 0

// Drawing and norm drawing params
#define X_RES 100 // Sample resolution in pixels
#define Y_RES 80  // MUST BE A MULTIPLE OF 8 (or else)

#define X_SCALED 15
#define Y_SCALED 12

#define PIX_DENSITY_THRESHOLD (0.1)

// Flash memory params
#define PAGE_START_HID 8
#define PAGE_START_OUT 157

// Neural network params
#define OUTPUT_NODE_CT 26
#define HIDDEN_NODE_CT 108

// ADC stuff
#define ADC_VREF_5 (1<<REFS0)
#define ADC_VREF_SET(x) ADMUX = (ADMUX & ~(0b11000000)) | x

#define ADC0 0
#define ADC1 1
#define ADC_PIN_SEL(x) ADMUX = (ADMUX & ~(0b00011111)) | x

// Red and Green LEDS
#define LED_D5 (1<<5) // red
#define LED_D4 (1<<4) // grn

// Touchpad interaction constants
#define TOUCHPAD_SAMPLE_PERIOD 1
#define PAUSE_TIME 500

#define X_MIN_1024 190 // for testing purposes
#define X_MAX_1024 940 // TODO: write an automatic calibration tool for these values
#define Y_MIN_1024 230
#define Y_MAX_1024 920

// Button interaction constants
#define BUTTON_DELAY_PERIOD 600
#define BUTTON_UPDATE_PERIOD 40

#endif
