#ifndef _DRAWING_H
#define _DRAWING_H

// Functions necessary to access
// or set it or do anything to an X_RES x Y_RES drawing.

#include "constants.h"
#include <inttypes.h>

// clear all pixels in the drawing
void clear_drawing(uint8_t drawing[X_RES][Y_RES/8]);

// set value at (x,y) in drawing
void set_matrix(uint8_t drawing[X_RES][Y_RES/8], uint8_t, uint8_t, uint8_t);

// get value at (x,y) in drawing
uint8_t get_matrix(uint8_t drawing[X_RES][Y_RES/8], uint8_t, uint8_t);

// print the drawing
void print_drawing(uint8_t drawing[X_RES][Y_RES/8]);

// Reduces a portion of the drawing to an X_SCALED-by-Y_SCALED resolution picture.
// Large drawing is in input, result is put into output.
// The last 4 arguments define the bounds on the box defining the portion of the drawing to scale.
void change_size(uint8_t input[X_RES][Y_RES/8], uint8_t output[X_SCALED][(Y_SCALED+7)/8], uint8_t x_begin, uint8_t x_end, uint8_t y_begin, uint8_t y_end);

#endif
