#ifndef _LETTERS_H
#define _LETTERS_H

#include <inttypes.h>
#include "constants.h"

uint8_t POV_mode;

// Colors for POV display
typedef enum color {
	AQUA,
	FUSCHIA,
	OLIVE,
	RED,
	ORANGE,
	YELLOW,
	GREEN,
	BLUE,
	PURPLE
} color_t;

// Choose a random POV color
color_t get_random_color(void);

// Prints a letter to the POV at position (0-13) with color color.
void print_char_to_POV(char let, uint8_t position, color_t color);

// Clears the letter let in the POV at position (0-13).
void clear_char_in_POV(char let, uint8_t position);

// Send special packet which is request to clear entire POV display
void send_clearall_msg(void);

// Send a 15-by-12 drawing to be displayed on the POV with color color.
void send_drawing(uint8_t drawing[X_SCALED][(Y_SCALED+7)/8], color_t color);

#endif
