function [fail errscore] = showNetPerformance(net, alphs, alph_select)

result = [];
success = [];
fail = [];

for i=1:26
    [choice classf] = calculate_output(net, alphs{alph_select}{i});
    result = [result; classf];
    if choice == i
        success = [success char('A'+i-1)];
    else
        fail = [fail char('A'+i-1)];
    end
end

% determine score - square error
score_let = sum((eye(26)-result).^2, 2);
errscore = sum(score_let);

s=size(result);
result = [result; zeros(1,s(1))];
result = [result zeros(s(2)+1,1)];

disp('Success:');
disp(success);
disp('Fail:');
disp(fail);
disp('Individual Letter Error scores:');
for i=1:26
    fprintf('%c: %.3f\n', 'A'-1+i, score_let(i));
end
disp('Overall Error score:');
disp(errscore);

figure;
pcolor(result);
title(sprintf('NN Performance on alphabet %d', alph_select));
ylabel('Letter to be classified');
xlabel('Classification strength as this letter (dark red = high)');
set(gca,'YTick',1:26);
set(gca,'XTick',1:26);
set(gca,'XTickLabel',[ones(26,4)*' ' reshape('A':'Z', 26, 1)]);
set(gca,'YTickLabel',reshape('A':'Z', 26, 1));
end