//Justin Churchill (jec324), Stephen Wu (shw46)
//ECE 4760 Lab 5
//FlashMemTest

#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>
#include <util/delay.h>
#include "uart.h"
#include "spiflash.h"
#include "constants.h"

// UART file descriptor
// putchar and getchar are in uart.c
FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

void initialize(void) {
	uart_init();
	stdout = stdin = stderr = &uart_str;
	DDRD |= 0b00110000;
	SPI_MasterInit();
}


int main(void) {
	initialize();

	fprintf(stdout, "Reading from flash.\n\n");

	flash_read_init(PAGE_START_HID);
	
	fprintf(stdout, "Hidden layer weights in flash:\n");
	PORTD |= (LED_D4);
	// Read all weight values from flash and show to serial.
	for(int i=0; i<HIDDEN_NODE_CT; i++) {
		for(int j=0; j<X_SCALED*Y_SCALED+1; j++) {
			char val[10];
			float wt = flash_read_next_float();
			dtostrf(wt, 6, 6, val);
			fprintf(stdout, "\tFrom input node %d: %s\n", j+1, val);
		}
	}

	flash_read_complete();

	flash_read_init(PAGE_START_OUT);
	
	fprintf(stdout, "Output layer weights in flash:\n");

	// Read all weight values from flash and show to serial.
	for(int i=0; i<OUTPUT_NODE_CT; i++) {
		for(int j=0; j<HIDDEN_NODE_CT+1; j++) {
			char val[10];
			float wt = flash_read_next_float();
			dtostrf(wt, 6, 6, val);
			fprintf(stdout, "\tFrom input node %d: %s\n", j+1, val);
		}
	}

	flash_read_complete();

	fprintf(stdout, "Complete!\n");
	PORTD |= (LED_D4 + LED_D5);
	while(1);
}
