//Justin Churchill (jec324), Stephen Wu (shw46)
//ECE 4760 Lab 5
//lcd_functions.c

#include "lcd_functions.h"
#include "letters.h"
#include "transmit.h"
#include <avr/pgmspace.h>
#include "lcd_lib.h"
#include <inttypes.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <util/delay.h>
#include "constants.h"

const uint8_t LCD_hello[] PROGMEM =     "Touchpad Letter \0";
const uint8_t LCD_hello2[] PROGMEM =    "  Recognition   \0";
const uint8_t LCD_blank[] PROGMEM =     "                \0";

char POV_chars[14]; // used to send data to David Bjanes and Jun Ma's "Persistence of Vision Display" project
char LCD_line[17]; // stores second line of LCD

// prints c to the LCD at location (x,y)
void print_char_to_LCD(char c, int x, int y) {
	sprintf(lcd_buffer,"%c",c);	                 
	LCDGotoXY(x, y);
	LCDstring(lcd_buffer, strlen(lcd_buffer));
	if (LCD_y == 1) {
		LCD_line[x] = c;
	}
	if (LCD_y == 0 && LCD_x < 14) {
		POV_chars[x] = c;
	}
}

// advance cursor one space
void LCD_forward(void) {
	if (LCD_x == 15 && LCD_y == 0) {
		LCD_x = 0;
		LCD_y = 1;
	}
	else if (LCD_x == 15 && LCD_y == 1) {
		LCD_x = 0;
		LCDGotoXY(0, 0);
		LCDstring(LCD_line, strlen(LCD_line));
		CopyStringtoLCD(LCD_blank, 0, 1);
	}
	else {
		LCD_x++;
	}
	print_char_to_LCD('_', LCD_x, LCD_y);
}

// print a space
void LCD_space(void) {
	print_char_to_LCD(' ', LCD_x, LCD_y);
	LCD_forward();
}

// delete last char
void LCD_backspace(void) {
	print_char_to_LCD(' ', LCD_x, LCD_y);
	if (LCD_x == 0 && LCD_y == 1) {
		LCD_x = 15;
		LCD_y = 0;
	}
	else if (LCD_x > 0) {
		LCD_x--;
	}
	if(LCD_x < 14 && POV_mode == true) {
		PORTD &= ~LED_D4; // Green off
		PORTD |= LED_D5;  // Red on	
		clear_char_in_POV(POV_chars[LCD_x], LCD_x);
	}
	print_char_to_LCD('_', LCD_x, LCD_y);
}

// clear whole lcd
void LCD_clear(void) {
	LCDclr();
	LCD_x = 0;
	LCD_y = 0;
	print_char_to_LCD('_', LCD_x, LCD_y);
	if(POV_mode == true) {
		PORTD &= ~LED_D4; // Green off
		PORTD |= LED_D5;  // Red on	
		send_clearall_msg();
	}
}


void init_LCD(void) {
	for(int i=0;i<16;i++) {
		LCD_line[i] = ' ';
	}
	LCD_line[16] = 0;
	
	LCDinit();	//initialize the display
	LCDcursorOFF();
	LCD_clear();				//clear the display
	LCDGotoXY(0,0);
	CopyStringtoLCD(LCD_hello, 0, 0);
	CopyStringtoLCD(LCD_hello2, 0, 1);

}
